'use strict';
(function(Nuvola)
{
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/main.js'
var global = Function('return this')() || (0, eval)('this');
Nuvola.global = global;
try
{
    window; // ReferenceError with bare Global Object
}
catch (e)
{
    global.window = null;
}
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/prototype.js'
var $prototype = function(proto, mixins)
{
    if (proto === undefined)
        throw new Error("Proto argument must be specified. Can be null.");
    var object = Object.create(proto);
    var len = arguments.length;
    for (var i = 1; i < len; i++)
    {
        var mixin = arguments[i];
        for (var name in mixin)
            object[name] = mixin[name];
    }
    return object;
}
var $object = function(proto, init_args)
{
    if (proto === undefined)
        throw new Error("Proto argument must be specified. Can be null.");
    var object = Object.create(proto);
    if (object.$init)
        object.$init.apply(object, [].slice.call(arguments, 1));
    return object;
}
Nuvola.$object = $object;
Nuvola.$prototype = $prototype;
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/signals.js'
var SignalsMixin = {};
SignalsMixin.addSignal = function(name)
{
    if (this.signals == null)
        this.signals = {};
    this.signals[name] = [];
}
SignalsMixin.registerSignals = function(signals)
{
    if (this.signals === undefined)
        this.signals = {};
    var size = signals.length;
    for (var i = 0; i < size; i++)
    {
        this.signals[signals[i]] = [];
    }
}
SignalsMixin.connect = function(name, object, handlerName)
{
    handlerName = handlerName || ("_on" + name);
    var handlers = this.signals[name];
    if (handlers === undefined)
        throw new Error("Unknown signal '" + name + "'.");
    handlers.push([object, handlerName]);
}
SignalsMixin.disconnect = function(name, object, handlerName)
{
    handlerName = handlerName || ("_on" + name);
    var handlers = this.signals[name];
    if (handlers === undefined)
        throw new Error("Unknown signal '" + name + "'.");
    var size = handlers.length;
    for (var i = 0; i < size; i++)
    {
        var handler = handlers[i];
        if (handler[0] === object && handler[1] === handlerName)
        {
            handlers.splice(i, 1);
            break;
        }
    }
},
SignalsMixin.emit = function(name, varArgsList)
{
    var handlers = this.signals[name];
    if (handlers === undefined)
        throw new Error("Unknown signal '" + name + "'.");
    var size = handlers.length;
    var args = [this];
    for (var i = 1; i < arguments.length; i++)
        args.push(arguments[i]);
    for (var i = 0; i < size; i++)
    {
        var handler = handlers[i];
        var object = handler[0];
        object[handler[1]].apply(object, args);
    }
}
Nuvola.SignalsMixin = SignalsMixin;
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/core.js'
var Core = $prototype(null, SignalsMixin);
Core.$init = function()
{
    this.addSignal("InitAppRunner");
    this.addSignal("InitializationForm");
    this.addSignal("InitWebWorker");
    this.addSignal("InitWebWorkerHelper");
    this.addSignal("HomePageRequest");
    this.addSignal("NavigationRequest");
    this.addSignal("ResourceRequest");
    this.addSignal("LastPageRequest");
    this.addSignal("QuitRequest");
    this.addSignal("UriChanged");
    this.addSignal("PreferencesForm");
    this.addSignal("ComponentLoaded");
    this.addSignal("ComponentUnloaded");
}
Core.getComponentInfo = function(id)
{
    return Nuvola._sendMessageSync("Nuvola.Core.getComponentInfo", id + "");
}
Core.isComponentLoaded = function(id)
{
    var info = this.getComponentInfo(id);
    return info.loaded;
}
Nuvola.Core = Core;
Nuvola.core = $object(Core);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/menubar.js'
var MenuBar = $prototype(null);
MenuBar.setMenu = function(id, label, actions)
{
    Nuvola._sendMessageAsync("Nuvola.MenuBar.setMenu", id, label, actions);
}
Nuvola.MenuBar = MenuBar;
Nuvola.menuBar = $object(MenuBar);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/utils.js'
Nuvola.format = function()
{
    var args = arguments;
    return args[0].replace(Nuvola.format._regex, function (item)
    {
        var index = parseInt(item.substring(1, item.length - 1));
        if (index > 0)
            return typeof args[index] !== 'undefined' ? args[index] : "";
        else if (index === -1)
            return "{";
        else if (index === -2)
            return "}";
        return "";
    });
};
Nuvola.format._regex = new RegExp("{-?[0-9]+}", "g");
Nuvola.inArray = function(array, item)
{
    return array.indexOf(item) > -1;
}
Nuvola.triggerMouseEvent = function(elm, name)
{
    var event = document.createEvent('MouseEvents');
    event.initMouseEvent(name, true, true, document.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, elm);
    elm.dispatchEvent(event);
}
Nuvola.clickOnElement = function(elm)
{
    Nuvola.triggerMouseEvent(elm, 'mouseover');
    Nuvola.triggerMouseEvent(elm, 'mousedown');
    Nuvola.triggerMouseEvent(elm, 'mouseup');
    Nuvola.triggerMouseEvent(elm, 'click');
}
Nuvola.makeText = function(text)
{
    return document.createTextNode(text);
}
Nuvola.makeElement = function(name, attributes, text)
{
    var elm = document.createElement(name);
    attributes = attributes || {};
    for (var key in attributes)
        elm.setAttribute(key, attributes[key]);
    if (text !== undefined && text !== null)
        elm.appendChild(Nuvola.makeText(text));
    return elm;
}
Nuvola.objectDiff = function(object1, object2)
{
    var changes = [];
    for (var property in object1)
    {
        if (object1.hasOwnProperty(property)
        && (!object2.hasOwnProperty(property) || object1[property] !== object2[property]))
            changes.push(property);
    }
    return changes;
}
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/logging.js'
Nuvola.log = function(template)
{
    var args = Array.prototype.slice.call(arguments);
    var message = Nuvola.format.apply(Nuvola, args);
    Nuvola._log(message);
}
Nuvola.warn = function(template)
{
    var args = Array.prototype.slice.call(arguments);
    var message = Nuvola.format.apply(Nuvola, args);
    Nuvola._warn(message);
}
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/launcher.js'
var Launcher = $prototype(null);
Launcher.setTooltip = function(tooltip)
{
    Nuvola._sendMessageAsync("Nuvola.Launcher.setTooltip", tooltip || "");
}
Launcher.setActions = function(actions)
{
    Nuvola._sendMessageAsync("Nuvola.Launcher.setActions", actions);
}
Launcher.removeActions = function()
{
    Nuvola._sendMessageAsync("Nuvola.Launcher.removeActions");
}
Launcher.addAction = function(action)
{
    Nuvola._sendMessageAsync("Nuvola.Launcher.addAction", action);
}
Launcher.removeAction = function(action)
{
    Nuvola._sendMessageAsync("Nuvola.Launcher.removeAction", action);
}
Nuvola.Launcher = Launcher;
Nuvola.launcher = $object(Launcher);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/notification.js'
var Notification = $prototype(null);
Notification.$init = function(name, resident, category)
{
    this.name = name;
    this.resident = !!resident;
    this.category = category || "";
}
Notification.update = function(title, text, iconName, iconPath, resident)
{
    if (resident == null)
        resident = this.resident;
    else
        this.resident = !!resident;
    Nuvola._sendMessageAsync("Nuvola.Notification.update",
        this.name, title, text, iconName || "", iconPath || "", !!resident, this.category);
}
Notification.setActions = function(actions)
{
    Nuvola._sendMessageAsync("Nuvola.Notification.setActions", this.name, actions);
}
Notification.removeActions = function()
{
    Nuvola._sendMessageAsync("Nuvola.Notification.removeActions", this.name);
}
Notification.show = function(force)
{
    Nuvola._sendMessageAsync("Nuvola.Notification.show", this.name, !!force);
}
var Notifications = $prototype(null);
Notifications.getNamedNotification = function(name, resident, category)
{
    return $object(Notification, name, resident, category);
}
Notifications.isPersistenceSupported = function()
{
    return Nuvola._sendMessageSync("Nuvola.Notifications.isPersistenceSupported");
}
Notifications.showNotification = function(title, text, iconName, iconPath, force, category)
{
    Nuvola._sendMessageAsync("Nuvola.Notifications.showNotification", title, text || "", iconName || "", iconPath || "", !!force, category || "");
}
Nuvola.Notification = Notification;
Nuvola.Notifications = Notifications;
Nuvola.notifications = $object(Notifications);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/storage.js'
var KeyValueStorage = $prototype(null);
KeyValueStorage.$init = function(index)
{
    this.index = index;
}
KeyValueStorage.setDefault = function(key, value)
{
    Nuvola._keyValueStorageSetDefaultValue(this.index, key, value);
}
KeyValueStorage.hasKey = function(key)
{
    return Nuvola._keyValueStorageHasKey(this.index, key);
}
KeyValueStorage.get = function(key)
{
    return Nuvola._keyValueStorageGetValue(this.index, key);
}
KeyValueStorage.set = function(key, value)
{
    if (Object.prototype.toString.call(value) == "[object Object]")
        throw new Error("Key-value storage is for primitive types only. It is not yet possible to store objects.");
    Nuvola._keyValueStorageSetValue(this.index, key, value);
}
var ConfigStorage = $prototype(KeyValueStorage, SignalsMixin);
ConfigStorage.$init = function()
{
    KeyValueStorage.$init.call(this, 0);
    this.addSignal("ConfigChanged");
}
var SessionStorage = $prototype(KeyValueStorage);
SessionStorage.$init = function()
{
    KeyValueStorage.$init.call(this, 1);
}
Nuvola.KeyValueStorage = KeyValueStorage;
Nuvola.ConfigStorage = ConfigStorage;
Nuvola.SessionStorage = SessionStorage;
Nuvola.session = $object(SessionStorage);
Nuvola.config = $object(ConfigStorage);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/gettext.js'
var Translate = {};
Translate.gettext = function(text)
{
    return text;
}
Translate.pgettext = function(context, text)
{
    if (!context)
    {
        Nuvola.warn("Context information passed to Translate.pgettext is invalid: {1}, '{2}'", context, text);
        return Translate.gettext(text);
    }
    return text;
}
Translate.ngettext = function(text1, text2, n)
{
    return n == 1 ? text1 : text2;
}
Nuvola.Translate = Translate;
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/actions.js'
var Actions = $prototype(null, SignalsMixin);
Actions.$init = function()
{
    this.addSignal("ActionActivated");
    this.addSignal("ActionEnabledChanged");
    this.connect("ActionActivated", this);
    this.connect("ActionEnabledChanged", this);
    this.buttons = {};
    this.enabledFlagsCache = {};
    this.statesCache = {};
}
Actions.addAction = function(group, scope, name, label, mnemo_label, icon, keybinding, state)
{
    var state = state !== undefined ? state: null;
    Nuvola._sendMessageSync("Nuvola.Actions.addAction", group, scope, name, label || "", mnemo_label || "", icon || "", keybinding || "", state);
}
Actions.addRadioAction = function(group, scope, name, stateId, options)
{
    Nuvola._sendMessageSync("Nuvola.Actions.addRadioAction", group, scope, name, stateId, options);
}
Actions._onActionActivated = function(arg1, action)
{
    console.log("JS API: Action activated: " + action);
}
Actions.isEnabled = function(name)
{
    return Nuvola._sendMessageSync("Nuvola.Actions.isEnabled", name);
}
Actions.setEnabled = function(name, enabled)
{
    return Nuvola._sendMessageSync("Nuvola.Actions.setEnabled", name, enabled);
}
Actions.updateEnabledFlag = function(name, enabled)
{
    if (enabled !== this.enabledFlagsCache[name])
    {
        this.enabledFlagsCache[name] = enabled;
        this.setEnabled(name, enabled);
    }
}
Actions.updateEnabledFlags = function(enabledFlags)
{
    for (var name in enabledFlags)
        this.updateEnabledFlag(name, enabledFlags[name]);
}
Actions.getState = function(name)
{
    return Nuvola._sendMessageSync("Nuvola.Actions.getState", name);
}
Actions.setState = function(name, state)
{
    return Nuvola._sendMessageSync("Nuvola.Actions.setState", name, state);
}
Actions.updateState = function(name, state)
{    
    if (state !== this.statesCache[name])
    {
        this.statesCache[name] = state;
        this.setState(name, state);
    }
}
Actions.updateStates = function(states)
{    
    for (var name in states)
        this.updateState(name, states[name]);
}
Actions.activate = function(name, parameter)
{
    Nuvola._sendMessageAsync("Nuvola.Actions.activate", name, parameter == null ? null : parameter);
}
Actions.bindButton = function(button, name, parameter)
{
    this.buttons[name] = button;
    button.disabled = !this.isEnabled(name);
    var that = this;
    button.addEventListener('click', function()
    {
        that.activate(name, parameter);
    });
}
Actions._onActionEnabledChanged = function(object, name, enabled)
{
    if (this.buttons[name])
        this.buttons[name].disabled = !enabled;
}
Nuvola.Actions = Actions;
Nuvola.actions = $object(Actions);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/mediakeys.js'
var MediaKey = {
    PLAY: "Play",
    PAUSE: "Pause",
    STOP: "Stop",
    PREV: "Previous",
    NEXT: "Next"
};
var MediaKeys = $prototype(null, SignalsMixin);
MediaKeys.$init = function()
{
    this.addSignal("MediaKeyPressed");
}
Nuvola.MediaKey = MediaKey;
Nuvola.MediaKeys = MediaKeys;
Nuvola.mediaKeys = $object(MediaKeys);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/browser.js'
var BrowserAction = {
    GO_BACK: "go-back",
    GO_FORWARD: "go-forward",
    GO_HOME: "go-home",
    RELOAD: "reload",
}
var Browser = $prototype(null);
Browser.$init = function()
{
    this._downloadFileAsyncId = 0;
    this._downloadFileAsyncCallbacks = {}
}
Browser.downloadFileAsync = function(uri, basename, callback, data)
{
    var id = this._downloadFileAsyncId++;
    if (this._downloadFileAsyncId >= Number.MAX_VALUE - 1)
        this._downloadFileAsyncId = 0;
    this._downloadFileAsyncCallbacks[id] = [callback, data];
    Nuvola._sendMessageAsync("Nuvola.Browser.downloadFileAsync", uri, basename, id);
},
Browser._downloadDone = function(id, success, statusCode, statusText, filePath, fileURI)
{
    var cb = this._downloadFileAsyncCallbacks[id];
    delete this._downloadFileAsyncCallbacks[id];
    cb[0]({
        success: success,
        statusCode: statusCode,
        statusText: statusText,
        filePath: filePath,
        fileURI: fileURI
    }, cb[1]);
}
Nuvola.BrowserAction = BrowserAction;
Nuvola.Browser = Browser;
Nuvola.browser = $object(Browser);
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/mediaplayer.js'
var PlayerAction = {
    PLAY: "play",
    TOGGLE_PLAY: "toggle-play",
    PAUSE: "pause",
    STOP: "stop",
    PREV_SONG: "prev-song",
    NEXT_SONG: "next-song",
    PLAYBACK_NOTIFICATION: "playback-notification",
}
var PlaybackState = {
    UNKNOWN: 0,
    PAUSED: 1,
    PLAYING: 2,
}
var COMPONENT_NOTIFICATIONS = "notifications";
var MediaPlayer = $prototype(null);
MediaPlayer.$init = function()
{
    this._appRunner = false;
    this._state = null;
    this._artworkFile = null;
    this._canGoPrev = null;
    this._canGoNext = null;
    this._canPlay = null;
    this._canPause = null;
    this._extraActions = [];
    this._artworkLoop = 0;
    this._baseActions = [PlayerAction.TOGGLE_PLAY, PlayerAction.PLAY, PlayerAction.PAUSE, PlayerAction.PREV_SONG, PlayerAction.NEXT_SONG];
    this._notification = null;
    Nuvola.core.connect("InitAppRunner", this);
    Nuvola.core.connect("InitWebWorker", this);
}
MediaPlayer.setTrack = function(track)
{
    var changed = Nuvola.objectDiff(this._track, track);
    if (!changed.length)
        return;
    this._track = track;
    if (!track.artLocation)
        this._artworkFile = null;
    if (Nuvola.inArray(changed, "artLocation") && track.artLocation)
    {
        this._artworkFile = null;
        var artworkId = this._artworkLoop++;
        if (this._artworkLoop > 9)
            this._artworkLoop = 0;
        Nuvola.browser.downloadFileAsync(track.artLocation, "player.artwork." + artworkId, this._onArtworkDownloaded.bind(this), changed);
        this._sendDevelInfo();
    }
    else
    {
        this._updateTrackInfo(changed);
    }
}
MediaPlayer.setPlaybackState = function(state)
{
    if (this._state !== state)
    {
        this._state = state;
        Nuvola.actions.setEnabled(PlayerAction.PLAYBACK_NOTIFICATION, this._state !== PlaybackState.UNKNOWN);
        this._setActions();
        this._updateTrackInfo(["state"]);
    }
}
MediaPlayer.setCanGoNext = function(canGoNext)
{
    if (this._canGoNext !== canGoNext)
    {
        this._canGoNext = canGoNext;
        Nuvola.actions.setEnabled(PlayerAction.NEXT_SONG, !!canGoNext);
        Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setFlag", "can-go-next", !!canGoNext);
        this._showNotification();
        this._sendDevelInfo();
    }
}
MediaPlayer.setCanGoPrev = function(canGoPrev)
{
    if (this._canGoPrev !== canGoPrev)
    {
        this._canGoPrev = canGoPrev;
        Nuvola.actions.setEnabled(PlayerAction.PREV_SONG, !!canGoPrev);
        Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setFlag", "can-go-previous", !!canGoPrev);
        this._showNotification();
        this._sendDevelInfo();
    }
}
MediaPlayer.setCanPlay = function(canPlay)
{
    if (this._canPlay !== canPlay)
    {
        this._canPlay = canPlay;
        Nuvola.actions.setEnabled(PlayerAction.PLAY, !!canPlay);
        Nuvola.actions.setEnabled(PlayerAction.TOGGLE_PLAY, !!(this._canPlay || this._canPause));
        Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setFlag", "can-play", !!canPlay);
        this._showNotification();
        this._sendDevelInfo();
    }
}
MediaPlayer.setCanPause = function(canPause)
{
    if (this._canPause !== canPause)
    {
        this._canPause = canPause;
        Nuvola.actions.setEnabled(PlayerAction.PAUSE, !!canPause);
        Nuvola.actions.setEnabled(PlayerAction.STOP, !!canPause);
        Nuvola.actions.setEnabled(PlayerAction.TOGGLE_PLAY, !!(this._canPlay || this._canPause));
        Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setFlag", "can-pause", !!canPause);
        Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setFlag", "can-stop", !!canPause);
        this._showNotification();
        this._sendDevelInfo();
    }
}
MediaPlayer.addExtraActions = function(actions)
{
    var update = false;
    for (var i = 0; i < actions.length; i++)
    {
        var action = actions[i];
        if (!Nuvola.inArray(this._extraActions, action))
        {
            this._extraActions.push(action);
            update = true;
        }
    }
    if (update)
        this._updateMenu();
}
MediaPlayer._BACKGROUND_PLAYBACK = "player.background_playback";
MediaPlayer._onInitAppRunner = function(emitter)
{
    this._appRunner = true;
    Nuvola.launcher.setActions(["quit"]);
    Nuvola.actions.addAction("playback", "win", PlayerAction.PLAY, "Play", null, "media-playback-start", null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.PAUSE, "Pause", null, "media-playback-pause", null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.TOGGLE_PLAY, "Toggle play/pause", null, null, null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.STOP, "Stop", null, "media-playback-stop", null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.PREV_SONG, "Previous song", null, "media-skip-backward", null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.NEXT_SONG, "Next song", null, "media-skip-forward", null);
    Nuvola.actions.addAction("playback", "win", PlayerAction.PLAYBACK_NOTIFICATION, "Show playback notification", null, null, null);
    Nuvola.config.setDefault(this._BACKGROUND_PLAYBACK, true);
    Nuvola.core.connect("ComponentLoaded", this);
    Nuvola.core.connect("ComponentUnloaded", this);
    this._toggleNotifications(Nuvola.core.isComponentLoaded(COMPONENT_NOTIFICATIONS));
    this._updateMenu();
    Nuvola.core.connect("PreferencesForm", this);
}
MediaPlayer._onInitWebWorker = function(emitter)
{
    Nuvola.mediaKeys.connect("MediaKeyPressed", this);
    Nuvola.actions.connect("ActionActivated", this);
    Nuvola.core.connect("QuitRequest", this);
    this._track = {
        "title": undefined,
        "artist": undefined,
        "album": undefined,
        "artLocation": undefined
    };
    this.setPlaybackState(PlaybackState.UNKNOWN);
    this._setActions();
    Nuvola.core.connect("ComponentLoaded", this);
    Nuvola.core.connect("ComponentUnloaded", this);
    this._toggleNotifications(Nuvola.core.isComponentLoaded(COMPONENT_NOTIFICATIONS));
}
MediaPlayer._onActionActivated = function(emitter, name, param)
{
    switch (name)
    {
    case PlayerAction.PLAYBACK_NOTIFICATION:
        if (this._notification)
            this._notification.show();
        break;
    }
}
MediaPlayer._setActions = function()
{
    var actions = [this._state === PlaybackState.PLAYING ? PlayerAction.PAUSE : PlayerAction.PLAY, PlayerAction.PREV_SONG, PlayerAction.NEXT_SONG];
    actions = actions.concat(this._extraActions);
    actions.push("quit");
    Nuvola.launcher.setActions(actions);
}
MediaPlayer._sendDevelInfo = function()
{
    var info = {
        "title": this._track.title || null,
        "artist": this._track.artist || null,
        "album": this._track.album || null,
        "artworkLocation": this._track.artLocation || null,
        "artworkFile": this._artworkFile || null,
        "playbackActions": this._baseActions.concat(this._extraActions),
        "state": ["unknown", "paused", "playing"][this._state],
    };
    Nuvola._sendMessageAsync("Nuvola.MediaPlayer.setTrackInfo", info);
}
MediaPlayer._onArtworkDownloaded = function(res, changed)
{
    if (!res.success)
    {
        this._artworkFile = null;
        console.log(Nuvola.format("Artwork download failed: {1} {2}.", res.statusCode, res.statusText));
    }
    else
    {
        this._artworkFile = res.filePath;
    }
    this._updateTrackInfo(changed);
}
MediaPlayer._updateTrackInfo = function(changed)
{
    this._sendDevelInfo();
    var track = this._track;
    if (track.title)
    {
        this._updateNotification();
        var tooltip = track.artist ? Nuvola.format("{1} by {2}", track.title, track.artist) : track.title;
        Nuvola.launcher.setTooltip(tooltip);
    }
    else
    {
        Nuvola.launcher.setTooltip("Nuvola Player");
    }
}
MediaPlayer._updateNotification = function()
{
    var track = this._track;
    if (this._notification && track.title)
    {
        var title = track.title;
        var message;
        if (!track.artist && !track.album)
            message = "by unknown artist";
        else if(!track.artist)
            message = Nuvola.format("from {1}", track.album);
        else if(!track.album)
            message = Nuvola.format("by {1}", track.artist);
        else
            message = Nuvola.format("by {1} from {2}", track.artist, track.album);
        this._notification.update(title, message, this._artworkFile ? null : "nuvolaplayer", this._artworkFile);
        this._showNotification();
    }
}
MediaPlayer._showNotification = function()
{
    if (this._notification && (this._state === PlaybackState.PLAYING || Nuvola.notifications.isPersistenceSupported()))
        this._notification.show();
}
MediaPlayer._updateMenu = function()
{
    Nuvola.menuBar.setMenu("playback", "_Control", this._baseActions.concat(this._extraActions));
}
MediaPlayer._onQuitRequest = function(emitter, result)
{
    if (this._state === PlaybackState.PLAYING && Nuvola.config.get(this._BACKGROUND_PLAYBACK))
        result.approved = false;
}
MediaPlayer._onPreferencesForm = function(object, values, entries)
{
    values[this._BACKGROUND_PLAYBACK] = Nuvola.config.get(this._BACKGROUND_PLAYBACK);
    entries.push(["bool", this._BACKGROUND_PLAYBACK, "Keep playing in background when window is closed"]);
}    
MediaPlayer._onMediaKeyPressed = function(emitter, key)
{
    var A = Nuvola.actions;
    switch (key)
    {
    case MediaKey.PLAY:
    case MediaKey.PAUSE:
        A.activate(PlayerAction.TOGGLE_PLAY);
        break;
    case MediaKey.STOP:
        A.activate(PlayerAction.STOP);
        break;
    case MediaKey.NEXT:
        A.activate(PlayerAction.NEXT_SONG);
        break;
    case MediaKey.PREV:
        A.activate(PlayerAction.PREV_SONG);
        break;
    default:
        console.log(Nuvola.format("Unknown media key '{1}'.", key));
        break;
    }
}
MediaPlayer._onComponentLoaded = function(emitter, id)
{
    if (id == COMPONENT_NOTIFICATIONS)
        this._toggleNotifications(true);
}
MediaPlayer._onComponentUnloaded = function(emitter, id)
{
    if (id == COMPONENT_NOTIFICATIONS)
        this._toggleNotifications(false);
}
MediaPlayer._toggleNotifications = function(enabled)
{
    if (enabled)
    {
        this._notification = Nuvola.notifications.getNamedNotification("mediaplayer", true, "x-gnome.music");
        if (this._appRunner)
            this._notification.setActions([PlayerAction.PREV_SONG, PlayerAction.PLAY, PlayerAction.PAUSE, PlayerAction.NEXT_SONG]);
        else
            this._updateNotification();
    }
    else
    {
        this._notification = null;
    }
}
Nuvola.PlayerAction = PlayerAction;
Nuvola.PlaybackState = PlaybackState;
Nuvola.MediaPlayer = MediaPlayer;
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/webapp.js'
var WebApp = $prototype(null, SignalsMixin);
WebApp.LAST_URI = "web_app.last_uri";
WebApp.$init = function()
{
    this.meta = Nuvola.meta;
    var allowedURI = this.meta.allowed_uri;
    this.allowedURI = allowedURI ? new RegExp(allowedURI) : null;
    Nuvola.core.connect("HomePageRequest", this);
    Nuvola.core.connect("LastPageRequest", this);
    Nuvola.core.connect("NavigationRequest", this);
    Nuvola.core.connect("UriChanged", this);
    Nuvola.core.connect("InitAppRunner", this);
    Nuvola.core.connect("InitWebWorker", this);
    Nuvola.core.connect("InitWebWorkerHelper", this);
}
WebApp.start = function()
{
    Nuvola.webApp = $object(this);
}
WebApp._onHomePageRequest = function(emitter, result)
{
    result.url = this.meta.home_url;
}
WebApp._onLastPageRequest = function(emitter, request)
{
    request.url = Nuvola.config.get(this.LAST_URI) || null;
}
WebApp._onNavigationRequest = function(object, request)
{
    request.approved = this.allowedURI ? this.allowedURI.test(request.url) : true;
}
WebApp._onUriChanged = function(object, uri)
{
    Nuvola.config.set(this.LAST_URI, uri);
}
WebApp._onInitAppRunner = function(emitter)
{
}
WebApp._onInitWebWorker = function(emitter)
{
}
WebApp._onInitWebWorkerHelper = function(emitter)
{
}
Nuvola.WebApp = WebApp;
Nuvola.$WebApp = function()
{
    if (this !== Nuvola)
        throw new Error("Nuvola.$WebApp has been called incorrectly. Use `var WebApp = Nuvola.$WebApp();` idiom.");
    return $prototype(WebApp);
}
// Included file '/home/build/YPKG/root/nuvolaplayer/build/nuvolaplayer-3.0.4/src/mainjs/fallback.js'
var argsToString = function(args)
{
    var strings = [];
    for (var i = 0; i < args.length; i++)
        strings.push("" + args[i])
    return strings.join(" ");
}
if (!global.console)
    global.console = {};
if (!console.log)
{
    console.log = function()
    {
        Nuvola.warn("console.log() is not available, using Nuvola.log as a fallback. The following message might be incomplete.");
        Nuvola.log("{1}", argsToString(arguments));
    }
}
if (!console.debug)
{
    console.debug = function()
    {
        Nuvola.warn("console.debug() is not available, using Nuvola.log as a fallback. The following message might be incomplete.");
        Nuvola.log("{1}", argsToString(arguments));
    }
}
if (!global.alert)
{
    global.alert = function()
    {
        Nuvola.warn("alert() is not available, using Nuvola.log as a fallback. The following message might be incomplete.");
        Nuvola.log("{1}", argsToString(arguments));
    }
}
})(this);  // function(Nuvola)
